unit Roman;

interface

  type
    TRomanNumeral = class
        function toRoman(n : integer): string;
    end;

implementation

{ TRomanNumeral }

function TRomanNumeral.toRoman(n: integer): string;
var s : string;
begin
  s:='';

  while n>0 do begin
    while n>=1000 do begin
      n:=n-1000;
      s:=s+'M';
    end;

    // Make >=
    if n=900 then begin
      n:=n-900;
      s:=s+'CM';
    end;

    while n>=500 do begin
      n:=n-500;
      s:=s+'D';
    end;

    // Make >=
    if n=400 then begin
      n:=n-400;
      s:=s+'CD';
    end;

    while n>=100 do begin
      n:=n-100;
      s:=s+'C';
    end;

    // Make >=
    if n=90 then begin
      n:=n-90;
      s:=s+'XC';
    end;

    while n>=50 do begin
      n:=n-50;
      s:=s+'L';
    end;

    // Make >=
    if n=40 then begin
      n:=n-40;
      s:=s+'XL';
    end;

    while n>=10 do begin
      n:=n-10;
      s:=s+'X';
    end;

    // Make >=
    if n=9 then begin
      n:=n-9;
      s:=s+'IX';
    end;

    while n>=5 do begin
      n:=n-5;
      s:=s+'V';
    end;

    // Make >=
    if n=4 then begin
      n:=n-4;
      s:=s+'IV';
    end;

    while n>=1 do begin
      s:=s+'I';
      n:=n-1;
    end;
  end;

  toRoman := s;
end;

end.
