unit Roman;

interface
  type
    TRomanNumeral = class
      public
        function toRoman(n : integer): string;
    end;

implementation

const mapSize = 13;
type Map = record
            num : integer;
            roman : string;
           end;

     mMap = array [1..mapSize] of Map;

var s : string;
    t : mMap = ( (num:1000;roman:'M'),
                 (num:900; roman:'CM'),
                 (num:500; roman:'D'),
                 (num:400; roman:'CD'),
                 (num:100; roman:'C'),
                 (num:90;  roman:'XC'),
                 (num:50;  roman:'L'),
                 (num:40;  roman:'XL'),
                 (num:10;  roman:'X'),
                 (num:9;   roman:'IX'),
                 (num:5;   roman:'V'),
                 (num:4;   roman:'IV'),
                 (num:1;   roman:'I')
    );


function TRomanNumeral.toRoman(n: integer): string;
var s : string;
    i : integer;
begin
  s:='';

  for i := 1 to mapSize do begin
     while n >= t[i].num do begin
      s:=s+t[i].roman;
      n:=n-t[i].num;
     end;
  end;

  toRoman := s;
end;

end.
